/*
 * Copyright (c) 2010 by Texas Instruments Incorporated All Rights Reserved

 */
/* *********************** GLOBAL VARIABLES ******************************** */
var appName = "TI-Nspire&trade; Document Player";
var timeout = 9; // seconds
var userAgent = navigator.userAgent;
var chrome = /(Chrome[\/\s]\d+\.\d+)/ig;
var firefox =  /(Firefox[\/\s]\d+\.\d+)/ig;
var safari = /(Safari[\/\s]\d+\.\d+)/ig;
var ie =/(MSIE \d+\.\d+);/ig;
var default_archive = {
    //'lib/maclibs.jar' : isMacOS(), // Removing because Bug 103609
    //'lib/winlibs.jar' : isWinOS(), // Removing because Bug 103609
    'lib/docfw.jar' : true,
    // video deps (ONLY WINDOWS)
    'lib/DJNativeSwing.jar' : isWinOS(),
    'lib/DJNativeSwing-SWT.jar' : isWinOS(),
    'lib/jna_WindowUtils.jar' : isWinOS(),
    'lib/jna.jar' : isWinOS(),
    'lib/swt.jar' : isWinOS(),
    // default
    'lib/player-resources.jar' : true,
    'lib/nspire-player-fonts.jar' : true,
    'lib/xerces_2_5_0.jar' : true, // TNSP
    'lib/jmf.jar' : true, // TNSP
    'lib/plaf.jar' : true,
    'lib/jide-components.jar' : true,
    'lib/ManagementUtils.jar' : true,
    'lib/nspirejdk.jar' : true,
    'lib/commproxy.jar' : true,
    'lib/pxconnect.jar' : true,
    'lib/upgrade.jar' : true,
    'lib/jxlayer.jar' : true,
    'lib/PBTransform.jar' : true,
    'lib/res.jar' : true,
    'lib/nspire-player-license.jar' : true
 };
var default_parameters = {
	'image' : 'images/nspireloading.gif',
    'centerimage' : 'true',
    'draggable' : 'true',
    'version' : '3.2.0',
    'full_version_number' : '3.2.0.DEV',
    'boxmessage' : 'loading...',
    'boxborder' : 'false',
    'locale' : getUrlParameter("locale"),
    //'time' : ''+time+'',
    'java_arguments' : '-Xmn256m -Xmx512m -Dsun.awt.disableMixing=true -Djnlp.packEnabled=true -d32 -Dsun.java2d.noddraw=true -Dseparate_jvm=true',
    'separate_jvm' : 'true',
    'legacy_lifecycle' : 'true',
    'web_applet' : 'true',
    'load_native_code_file' : isMacOS(),
    'load_dynamic_lib' : isWinOS(),
    'codebase_lookup' : isMacOS(),
    'width' : '100%',
    'height' : '100%'
};
var default_attributes = {
	'code' : 'com.ti.et.phoenix.app.web.PlayerApplet',
    'align' : 'center',
    'width' : '100%',
    'height' : '100%',
    'id' : 'player1',
    'name' : 'TI-Nspire Document Player'
};

/* *********************** GLOBAL VARIABLES ******************************** */

/**
 * Simulates Hash implementation.
 */
function Hash() {
    this.length=0;
    this.entries = new Array();
    for (var i = 0; i < arguments.length; i += 2) {
        if (typeof(arguments[i+1]) != 'undefined') {
            this.put(arguments[i], arguments[i+1]);
        }
    }
}
/**
 * Sets up Hash prototype. 
 */
Hash.prototype = {
    length:0,
    entries:new Array(),
    /** 
     * Concats the given hash entry in the Hash entries. The hash must be 
     * typeof(this).
     */
    concatHash:function(hash) {
        if(typeof(hash) == typeof(this)) {
            for (var key in hash.entries) {
                this.put(key, hash.entries[key]);
            }
        }
    },
    /**
     * Concats the array in the Hash entries. The array must be initialized 
     * array['key'] = value;
     */
    concat:function(array) {
        if(typeof(array) != 'undefined') {
            for (var key in array) {
                this.put(key, array[key]);
            }
        }
    },
    /**
     * Concats the array in the Hash entries. The array is a simple array of 
     * objects. The function will takes pairs of values and use them to concat
     * to the set entries of this hash. More formally, this calls the next for 
     * each pair of values this.put(array[i], array[i + 1]).
     */
    concatKeyValuePairArray:function(array) {
        if(typeof(array) != 'undefined') {
            for (var i = 0; i < array.length; i += 2) {
                if (typeof(array[i + 1]) != 'undefined') {
                    this.put(array[i], array[i + 1]);
                }
            }
        }
    },
    /**
     * Concats the array in the Hash entries. The array is a simple array of 
     * objects. The function will takes pairs of values and use them to concat
     * to the set entries of this hash. More formally, this calls the next for 
     * each pair of values this.put(array[i], array[i + 1]).
     */
    putAll:function(params) {
        for (var i = 0; i < params.length; i += 2) {
            if (typeof(params[i + 1]) != 'undefined') {
                this.put(params[i], params[i + 1]);
            }
        }
    },
    /**
     * Puts the key value in the Hash.entries.
     * @return the added entry if defined key and value, null otherwise.
     */
    put:function(key, value) {
        var entry;
        if(typeof(value) == 'undefined') return entry;
        if(typeof(this.entries[key]) == 'undefined') {
            this.length++;
        } else {
            entry = this.entries[key];
        }
        this.entries[key] = value;
        return entry;
    },
    /**
     * Removes the entry if set for the given key.
     * @return the deleted entry if exist, null otherwise.
     */
    remove:function(key) {
        var entry;
        if (typeof(this.entries[key]) != 'undefined') {
            this.length--;
            var entry = this.entries[key];
            delete this.entries[key];
        }
        return entry;
    },
    /**
     * Gets the Hash.entry value if present for the given key.
     * @return the Hash.entry if present for the given key, undefined otherwise.
     */
    get:function(key) {
        return this.entries[key];
    },
    /**
     * Returns true if the Hash.entry key is present for the given key, false 
     * otherwise.
     * @return true if the Hash.entry key is present for the given key, false 
     * otherwise.
     */
    containsKey:function(key) {
        for (var i in this.entries) {
            if(i == key) return true;
        }
        return false;
    },
    /**
     * Returns true if the Hash.entry value is present for the given value, 
     * false otherwise.
     * @return true if the Hash.entry value is present for the given value, 
     * false otherwise.
     */
    containsValue:function(value) {
        for (var i in this.entries) {
            if(this.entries[i] == value) return true;
        }
        return false;
    },
    /**
     * Clears the entries of this Hash.
     */
    clear:function() {
        for (var i in this.entries) {
            delete this.entries[i];
        }
        this.length = 0;
    },
    /**
     * Override the to String function.
     */
    toString:function() {
        var str = "{";
        var first = true;
        for (var i in this.entries) {
            if(!first) str += ", ";
            str += i + ": '" + this.entries[i] + "'";
            first = false;
        }
        return str + "}";
    }
} // end of Hash.prototype.

/**
 * Imports javascript dependencies dinamically.
 */
function importDependencies() {
    jsscript = document.createElement('script');
    //jsscript.type = 'text/javasript';
    jsscript.src = 'http://www.java.com/js/deployJava.js';
    document.getElementsByTagName('head')[0].appendChild(jsscript);
    jsscript = document.createElement('script');
    //jsscript.type = 'text/javasript';
    jsscript.src = 'js/hash.js';
    document.getElementsByTagName('head')[0].appendChild(jsscript);
}
/**
 * Imports javascript dependencies dinamically.
 */
function importDependency(src) {
    jsscript = document.createElement('script');
    jsscript.type + 'text/javascript';
    jsscript.src = src + '';
    document.getElementsByTagName('head')[0].appendChild(jsscript);
}
/**
 * Gets the URL params in form of a Hash if present in 
 * window.location.search.substring(1).
 * @return a Hash of URL  params.
 */
function getURLParams() {
    /* TEST URLs:
     * http://localhost:8081/nspire-player-win/application/nspire-player.html?
     *      color=gray&otherfile=urlbegin%28http://test1.ti.com/myfile/
     *      index.jsp?file=test.tns&x=1&y=2%29urlend&nspirefile=file:///
     *      tns4.back.tns&x=1&y=2
     * http://localhost:8081/nspire-player-win/application/nspire-player.html?
     *      otherfile=urlbegin%28http://test1.ti.com/myfile/index.jsp?
     *      file=test.tns&x=1&y=2%29urlend&nspirefile=tns4.back.tns
     * http://localhost:8081/nspire-player-win/application/nspire-player.html?
     *      nspirefile=http://tns4.back.tns?otherfile=urlbegin(http://test1.ti.com/
     *      myfile/index.jsp?file=test.tns&x=1&y=2)urlend&nspirefile=tns4.back.tns
     * http://localhost:8081/nspire-player-win/application/nspire-player.html?
     *      nspirefile=urlbegin(file:///tns4.back.tns)urlend
     */
    var hash = new Hash();
    var vars = window.location.search.substring(1).split("&");
    if(vars == null || vars.length <= 0) return hash;
    //document.write("<br/>    URL params: " + vars+"<br/>");
    while(vars.length > 0) {
        //document.write("<br/><br/>Vars: " + vars);
        var keyvalue = vars.shift();
        //document.write("<br/>KeyValue: " + keyvalue);
        if(keyvalue != null && 
                typeof(keyvalue) != 'undefined') {
            var urlpattern = /^([\w]+=)[A-Za-z]+:(\/\/)*(\/)?.*/ig;
            var enclosedurlbegin = /^([\w]+=)(urlbegin)\(.*/ig;
            var enclosedurl = /^([\w]+=)(urlbegin)\(.*\)urlend/ig;
            var key = keyvalue.split("=",1);
            var varsjoin = vars.join("&");
            //document.write("<br/>VarsJoin: " + varsjoin);
            if(enclosedurlbegin.test(keyvalue)) {
                var value = "";
                // If the keyvalue contains the complete enclosedurl (i.e. 
                // /^([\w]+=)(urlbegin)\(.*\)urlend/ig) then just take out 
                // begin and end tags.
                if(enclosedurl.test(keyvalue)) {
                    value = keyvalue.replace(
                            key + "=urlbegin(", "").replace(")urlend", "");
                } else {
                    // if not contact the varsjoins until )urlend.
                    value = keyvalue.replace(key + "=urlbegin(", "") +  "&" + 
                        varsjoin.substring(0, varsjoin.indexOf(")urlend"));
                }
                //document.write("<br/>vars:" + varsjoin.replace(/.*\)urlend/, "").split("&"));
                vars = varsjoin.replace(/.*\)urlend/, "").split("&");
                if(typeof(key) != 'undefined' && typeof(value) != 'undefined')  
                    hash.put(key, value);
                //document.write("<br/>key: " + key + ", value: " +value);
            } else if(urlpattern.test(keyvalue)) {
                var key = keyvalue.split("=",1);
                var value = keyvalue.replace(key + "=", "");
                if(varsjoin != null && varsjoin != "")
                    value += "&" + varsjoin;
                if(typeof(key) != 'undefined' && typeof(value) != 'undefined')  
                    hash.put(key, value);
                break;
                //document.write("<br/>key: " + key + ", value: " +value);
            } else {
                var splited = keyvalue.split("=");
                if(typeof(splited[0]) != 'undefined' && 
                        typeof(splited[1]) != 'undefined')  
                    hash.put(splited[0], splited[1]);
                //document.write("<br/>key: " + splited[0] + ", value: " +splited[1]);
            }

        }
    }
    //document.write("<br/>Hash: " + hash);
    return hash;
}
/**
 * Resizes the applet windows as needed from the parent component.
 */
function resize() {
    var w_newWidth=800,w_newHeight=600;
    var w_maxWidth=1600, w_maxHeight=1200;
    if (navigator.appName.indexOf("Microsoft") != -1)
    {
        w_newWidth=document.body.clientWidth;
        w_newHeight=document.body.clientHeight;
    }else{
        var netscapeScrollWidth=15;
        w_newWidth=window.innerWidth-netscapeScrollWidth;
        w_newHeight=window.innerHeight-netscapeScrollWidth;
    }
    if (w_newWidth>w_maxWidth)
        w_newWidth=w_maxWidth;
    if (w_newHeight>w_maxHeight)
        w_newHeight=w_maxHeight;

    window.scroll(0,0);
}
/**
 * Checks if java is enabled. If not, alert the user java must be enabled in 
 * order to run this application.
 */
function checkJavaEnabled() { 
    if(!navigator.javaEnabled()) {
        return false;
    }
    return true;
}
/**
 * Gets the browser locale.
 * @return the browser locale if defined, en-us otherwise. 
 */
function getBrowserLocale() {
    var language = getUrlParameter("locale");
    if(language != null && language != '' && language != 'undefined') {
        return language;
    }
//    if (window.XMLHttpRequest)
//    {// code for IE7+, Firefox, Chrome, Opera, Safari
//        xmlhttp=new XMLHttpRequest();
//    }
//    else
//    {// code for IE6, IE5
//        xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
//    }
//    xmlhttp.onreadystatechange=function()
//    {
//        if (xmlhttp.readyState==4 && xmlhttp.status==200)
//        {
//            
//            language = xmlhttp.responseText;
//        }
//    }
//    xmlhttp.open("POST","http://localhost:8080/ti-services/getbrowserlocale",true);
//    xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
//    xmlhttp.send(params);
//    if ( navigator ) {
//        if ( navigator.language ) {
//            return navigator.language;
//        } else if ( navigator.browserLanguage ) {
//            return navigator.browserLanguage;
//        } else if ( navigator.systemLanguage ) {
//            return navigator.systemLanguage;
//        } else if ( navigator.userLanguage ) {
//            return navigator.userLanguage;
//        }
//    }
    //default locale
    return "en";
}
/**
 * Inners an demo html link for the given url into the given element id, if the 
 * nspireAppName equals to 'nspire-player'. This link will open in a new window.
 * @param url the url for the demo page.
 * @param nspireAppName the npsire application name (e.g. 'nspire-player').
 * @param elementId the element id to inners the html in.
 * @param appName the application name for link text.
 */
function innerDemoLink(url, inner, elementId, appName) {
    var element = document.getElementById(elementId);
    if(inner == true && element != null && url != null) {
        element.innerHTML=buildLink(url, screen.availWidth, screen.availHeight,
                "Click here to open the " + appName +  " demo page.");
    }
}
/**
 * Returns a html link for the given url, width, height and text if url 
 * different the null, empty string otherwise. Defaults with to 800, height
 * to 600 and text to 'Click here to open this link.' if nulls. This link will 
 * open in a new window.
 * @param url the url for the demo page. 
 * @param width the width to the new window. Default 800.
 * @param height the height to the new window. Default 600.
 * @param text the text append in the link. Default 'Click here to open this 
 * link.'.
 * @return a html link for the given url, width, height and text if url 
 * different the null, empty string otherwise.
 */
function buildLink(url, width, height, text) {
    if(width == null || width == "") width = 800;
    if(height == null || height == "") height = 600;
    if(text == null || text == "") text = "Click here to open this link.";
    if(url != null) {
        return "<a href=\"javascript: void(0)\"" +
        "onclick=\"window.open('"+url+"', '_blank', 'titlebar=no, " +
        "width="+screen.availWidth+", height="+screen.availHeight+",  " +
        "directories=no, location=no, menubar=no, resizable=yes, " +
        "scrollbars=yes, status=no, toolbar=no');" + 
        "return false;\">"+text+"</a>";
    }
    return "";
}
/**
 * Returns true if the OS is supported, false otherwise. Current supported 
 * OSs are Mac and Win32.
 * @return true if the OS is supported, false otherwise.
 */
function isSupportedOS() {
    var platform = navigator.platform;
    if(platform.indexOf("Mac")!= -1){
		if(navigator.userAgent.indexOf("OS X 10.6") != -1 
				|| navigator.userAgent.indexOf("OS X 10_6") != -1
				|| navigator.userAgent.indexOf("OS X 10.7") != -1 
				|| navigator.userAgent.indexOf("OS X 10_7") != -1){
			return true;
		}
	}    
	if(platform.indexOf("Win32") != -1) {
        return true;
    }
    return false;
}
/**
 * Returns the Browser name plus version if supported, 'Unknown Browser' 
 * otherwise.
 * @return true the Browser name plus version if supported, 'Unknown Browser' 
 * otherwise.
 */
function getBrowserVersion() {
    if(chrome.test(userAgent) ||
       firefox.test(userAgent) ||
       safari.test(userAgent)) {
        return RegExp.$1;
    } else if(ie.test(userAgent)) {
        return RegExp.$1.replace("MSIE", "Microsoft Internet Explorer");
        
    } else { 
        return getString(getBrowserLocale(), "unknown.browser.message");
    }
}
/**
 * Returns true if the Browser is supported, false otherwise. Current supported 
 * browsers are 'ie/7+', 'Chrome/4+', 'Firefox/4+' and 'Safari/4+'.
 * @return true if the Browser is supported, false otherwise.
 */
function isSupportedBrowser() {
    var userAgent = navigator.userAgent;
    var chrome = /Chrome[\/\s](\d+\.\d+)/ig;
    var firefox =  /Firefox[\/\s](\d+\.\d+)/ig;
    var safari = /Safari[\/\s](\d+\.\d+)/ig;
    var ie =/MSIE (\d+\.\d+);/ig;
    if(chrome.test(userAgent)) {
        var version = new Number(RegExp.$1);
        if(version >= 4) {
            return true;
        }
    } else if(firefox.test(userAgent)) {
        var version = new Number(RegExp.$1);
        if(version >= 4) {
            return true;
        }
    } else if(safari.test(userAgent) && isMacOS()) {
        var version = new Number(RegExp.$1);
        if(version >= 4) {
            return true;
        }
    } else if(ie.test(userAgent) && isWinOS()) {
        var version = new Number(RegExp.$1);
        if(version >= 7) {
            return true;
        }
        
    }
    return false;
    /*
    if(userAgent.indexOf("Chrome")!= -1 ||
        userAgent.indexOf("Firefox") != -1 ||
        userAgent.indexOf("Safari") != -1 ||
        userAgent.indexOf("MSIE") != -1) {
        return true;
    }
    return false;
    */
}

/**
 * Returns true if the Browser is Chrome, false otherwise.
 * @return true if the Browser is Chrome, false otherwise.
 */
function isRunningOnChromeBrowser() {
    var userAgent = navigator.userAgent;
    var chrome = /Chrome[\/\s](\d+\.\d+)/ig;
    if(chrome.test(userAgent)) {
        var version = new Number(RegExp.$1);
        if(version >= 4) {
            return true;
        }
    }
	return false;
}

/**
 * Returns true if the OS is supported, false otherwise. Current supported 
 * OSs are Mac and Win32.
 * @return true if the OS is supported, false otherwise.
 */
function isWinOS() {
    var platform = navigator.platform;
    if(platform.indexOf("Win32") != -1) {
        return true;
    }
    return false;
}
/**
 * Returns true if the OS is supported, false otherwise. Current supported 
 * OSs are Mac and Win32.
 * @return true if the OS is supported, false otherwise.
 */
function isMacOS() {
    var platform = navigator.platform;
    if(platform.indexOf("Mac")!= -1) {
        return true;
    }
    return false;
}
/**
 * Redirects to Java download page.
 */
function redirectToJavaDownload() {
    var objWindow = window.open('http://java.sun.com/webapps/getjava/BrowserRedirect?host=java.com', '_blank',  '');
    // Checks if the window was opened. If not, this means the browser blocks 
    // the pop up windows and we need to keep it opened to let the users click
    // on the Java Download link.
    if(typeof(objWindow) != 'undefined') {
        window.close();
    }
}
/**
 * Returns the given parameter if present in the window.location.href, empty 
 * string otherwise.
 * @param param the URL parameter.
 * @returns the given parameter if present in the window.location.href, empty 
 * string otherwise.
 */
function getUrlParameter(param) {
    param = param.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
    var r1 = "[\\?&]"+param+"=([^&#]*)";
    var r2 = new RegExp( r1 );
    var r3 = r2.exec( window.location.href );
    if( r3 == null ) return "";
    else return r3[1];
}
/**
 * Removes JavaScript not enabled message.
 */
function removeJavaScriptMessage() {
    var element = document.getElementById('javascript');
    if(element != null && typeof(element) != 'undefined') {
        element.innerHTML="";
        element.style.visibility='hidden';
        element.style.display='none';
    }
}
/**
 * Removes the given element id by hiddining and none displayining it.
 */
function removeElement(elementId) {
    var element = document.getElementById(elementId);
    if(element != null && typeof(element) != 'undefined') {
        element.innerHTML="";
        element.style.visibility='hidden';
        element.style.display='none';
    }
}
/**
 * Validates the requirements in order to run the TI-Nspire(tm) Document 
 * Player.
 */
function validate() {
    // TODO: add localization support for messages and text.
    // first remove unavailable to run javascript message
    removeJavaScriptMessage();
    var locale = getBrowserLocale();
	
	if(isSupportedOS() && isRunningOnChromeBrowser()){
		showPlayer(true);
	}else if(!isSupportedOS()) {
        var msg1 = getString(locale, "unsupported.browser.warn")
                .format(getBrowserVersion());
            var msg2 = getString(locale, "unsupported.browser.button");
            showMessage(msg1, msg2);
    } else if(!checkJavaEnabled() && 
        getBrowserVersion().search("Safari") != -1) {
        showMessage(getString(getBrowserLocale(), "java.enabled.error"));
    // Checks if the java version is installed.
    } else if(deployJava.versionCheck('1.6.0_22+')) {
        if(!isSupportedBrowser()) {
            var msg1 = getString(locale, "unsupported.browser.warn")
                .format(getBrowserVersion());
            var msg2 = getString(locale, "unsupported.browser.button");
            showMessage(msg1, msg2);
        } else if(isPluginInstalled('Platform SE 7', 'Java Plug-in 10') ||
        		deployJava.versionCheck('1.7+')){
        	// it has installed java 1.7 which is now supported on K12
        	// check 105310 for further information
//        	if(hasSupportedJRE('1.6.0_26')){
        		showPlayer(true);
//        	}else{
//        		// else show message and offer a valid jre
//        		var msg1 = getString(locale, "java.version7.error")
//        		.format(getBrowserVersion());
//        		if(isWinOS()){
//        			msg1 = msg1.replace("linktojavadownload", "http://download.oracle.com/otn-pub/java/jdk/6u27-b07/jre-6u27-windows-i586.exe");
//        		}else{
//        			msg1 = msg1.replace("linktojavadownload", "http://support.apple.com/downloads/DL1360/en_US/JavaForMacOSX10.6Update5.dmg");
//        		}        		
//        		showMessage(msg1);
//        	}
        } else if(!isNextGenerationOfJavaPluginEnabled()) {
            showMessage(getString(locale, 
                "java.plugin2.notenabled." + getOSName() +".warn"));
        } else { 
            showPlayer(true);
        }
    } else {
        // redirects to Java Download Page if the java version is not correct or 
        // java is not installed.
        var text = timeout;
        showMessage(getString(locale, "java.version.error").format(text));
//        countDown(timeout);
//        setTimeout('redirectToJavaDownload()',timeout * 1000); 
    }
}
/**
 * Returns true/false depending if computer has installed a supported java
 * version for Player
 */
function hasSupportedJRE(requiredJRE){
	// Supported JRE are from 1.6.0_22 or major but not 1.7
	var jres = deployJava.getJREs();
	var validjre = false;
	for(x in jres){
		//var required = "1.6.0_22"
		var a = jres[x].split('.');
		var b = requiredJRE.split('.');
		for (var i = 0; i < a.length-1; ++i) {
			a[i] = Number(a[i]);
		}
		for (var i = 0; i < b.length-1; ++i) {
			b[i] = Number(b[i]);
		}
		if (a[0] == b[0]){
			if (a[1] == b[1]){
				var c = a[2].split('_');
				var d = b[2].split('_');
				for (var i = 0; i < c.length; ++i) {
					c[i] = Number(c[i]);
					d[i] = Number(d[i]);
					if (c[0] > d[0]){
						return true;
					}else if(c[0] == d[0]){
						if(c[1] >= d[1]){
							return true;
						}
					}
				}
			}
		}
	}	
	return false;
}
/**
 * Inners html time in the element with 'timer' id if present until time is 
 * consume.
 * @param time the period of time to inner in the 'timer' id element.
 */
function countDown(time) {
    if(typeof(time) != 'undefined' && time != null) {
        var element = document.getElementById('timer');
        if(element != null && typeof(element) != 'undefined') {
            document.getElementById('timer').innerHTML=time--;
            if(time >= 0) { 
                setTimeout('countDown('+time+')',1000);
            }
        }
    }
}
/**
 * Rewrites the player and just calls showPlayer() method.
 * @param dummy the boolean value to run a dummy message.
 */
function loadPlayer(dummy) {
    removeElement('message');
    showPlayer();
}

function removeButtons() {
    var element = document.getElementById('button_actions');
    if(element != null && typeof(element) != 'undefined') {
        element.style.visibility="hidden";
        element.style.display="none";
    }
    var element = document.getElementById('button_message');
    if(element != null && typeof(element) != 'undefined') {
        element.style.visibility="hidden";
        element.style.display="none";
    }
}
/**
 * Shows Dummy message box.
 */
function showDummy() {
  showMessage("", false);
  var element = document.getElementById('message');
  if(element != null && typeof(element) != 'undefined') {
      element.style.display='none';
  }
}
/**
 * Show message boxes.
 * @param msg the message string.
 * @param button the button element in html.
 */
function showMessage(msg, button) {
    var message=
        "<div id=\"message-container\">" +
        "<div id=\"message\">" + 
        "  <div id=\"header-bar\"></div>" +
        "  <div id=\"table\">" +
        "    <div id=\"row\">" +
        "      <div id=\"cell-left\">" +
        "        <div id=\"table-content\">" +
        "          <h1><img src=\"images/error.png\">WARNING</h1>" + 
        "          {0}{1}" +
        "        </div>" +
        "      </div>" +
        "    </div>" +
        "  </div>" + 
        "</div>" +
        "</div>" +
        "<div style=\"clear: both;\"></div>";
    var str = "";
    if(button) { 
        str = message.format(msg, button);
    } else {
        str = message.format(msg, "");
    }
    var regex = new RegExp("\\{help\\}", "gm");
    str = str.replace(regex, getString(getBrowserLocale(),"help.link.message"));
    document.write(str);
}
/**
 * Shows player using deployJava and writing the applet tag.
 * @see <a href="http://www.java.com/js/deployJava.txt"/>deployJava</a>
 */
function showPlayer() {
    // resize the page.
    window.onResize = resize;
    window.onLoad = resize;
    // get time for metrics purposes.
    var time = new Date().getTime();
    // set the default java version
    var java_version = '1.6.0_22';
    // specific platform files. At this point we need to check with jnlp and 
    // backward compatibility we are gonna run.
    // new config direct jnlp hook 
    var attributes = new Hash(
        'code', 'com.ti.et.phoenix.app.web.PlayerApplet',
        'align', 'center'
    );
    attributes.concat({width:'100%', height:'100%', name:'TI-Nspire Document Player', style:'min-width:250px; min-height:250px;'});
    // strip the GET params from the URL if present
    var parameters = new Hash(
        'image', 'images/nspireloading.gif',
        'centerimage', 'true',
        'draggable', 'true',
        'version', '3.2.0',
        'full_version_number', '3.2.0.1219',
        'boxmessage', 'loading...',
        'boxborder', 'false',
        'locale', getUrlParameter("locale"),
        'time', ''+time+''
    );
    if(isMacOS()) {
    	var osName = isMacOS() ? "mac" : "win";
    	var archive = "";
    	for(var arch in default_archive) {
            // check if archive if available for this platform
            if(default_archive[arch] == true) {
                archive += osName + "/" + arch + ",";
            }
        }  
            
        codebase = location.href.replace(window.location.hash, "");
        codebase = codebase.replace(window.location.search, "");
        codebase = codebase.substring(0, codebase.lastIndexOf('/')+1) + '';
        attributes.concat({ codebase : codebase, archive: archive , 
            onmouseover : 'this.focus()' });
        parameters.concat({ load_native_code_file : 'true' });
        parameters.concat({ legacy_lifecycle : 'true' });
        parameters.concat({ web_applet : 'true'});
        parameters.concat({ java_arguments : '-Djnlp.packEnabled=true -d32 -Dseparate_jvm=true'});
    } else { 
        parameters.concat({ jnlp_href : 'nspire-player-win-web.jnlp' });
        parameters.concat({ load_dynamic_lib : 'true' });
        parameters.concat({ java_arguments : '-Dsun.awt.disableMixing=true -Djnlp.packEnabled=true -d32 -Dseparate_jvm=true'});
    }
    
    // concat build specific applet params.
    var paramsext = {separate_jvm: 'true', width:'100%', height:'100%'};
    parameters.concat(paramsext);
    // get URL parameters and override them if exist.
    var urlparams = getURLParams();
    parameters.concat(urlparams.entries);
    // run the applet
    deployJava.runApplet(attributes.entries, parameters.entries, java_version);
    // finally just resize the application after applet is displayed.
    resize;
}
/**
 * Reloads this page with no validations
 */
function reloadWithoutValidations(){
	window.location.search="?checkEnv=false";
}

function getURLParam(strParamName){
	var strReturn = "";
	var strHref = window.location.href;
	if ( strHref.indexOf("?") > -1 ){
		var strQueryString = strHref.substr(strHref.indexOf("?")).toLowerCase();
		var aQueryString = strQueryString.split("&");
		for ( var iParam = 0; iParam < aQueryString.length; iParam++ ){
			if (aQueryString[iParam].indexOf("=") > -1 ){
				var aParam = aQueryString[iParam].split("=");
				strReturn = aParam[1];
				break;
			}
		}
	}
	return strReturn;
}
/**
 * Checks whether is a valid environment or not
 * @returns {Boolean}
 */
function isValidEnvironment(){
	var locale = getBrowserLocale();
	if(getURLParam("checkEnv")=="false"){
		return true;
	}else{
		if(isSupportedOS() && isRunningOnChromeBrowser()){
			return true;
		}else if(!isSupportedOS()) {
	        var msg1 = getString(locale, "unsupported.browser.warn")
	                .format(getBrowserVersion());
	        var msg2 = getString(locale, "unsupported.browser.button.reload");
	        showMessage(msg1, msg2);
	        return false;    
	    } else if(!checkJavaEnabled() && 
	        getBrowserVersion().search("Safari") != -1) {
	        showMessage(getString(getBrowserLocale(), "java.enabled.error"));
	        return false;
	    // Checks if the java version is installed.
	    } else if(deployJava.versionCheck('1.6.0_22+')) {
	        if(!isSupportedBrowser()) {
	            var msg1 = getString(locale, "unsupported.browser.warn")
	                .format(getBrowserVersion());
	            var msg2 = getString(locale, "unsupported.browser.button.reload");
	            showMessage(msg1, msg2);
	            return false;
	        }else if(isPluginInstalled('Platform SE 7', 'Java Plug-in 10') ||
	        		deployJava.versionCheck('1.7+')){
	        	return true;
	        }else if(!isNextGenerationOfJavaPluginEnabled()) {
	            showMessage(getString(locale, 
	                "java.plugin2.notenabled." + getOSName() +".warn"));
	            return false;
	        } else { 
	            return true;
	        }
	    } else {
	        // redirects to Java Download Page if the java version is not correct or 
	        // java is not installed.
	        var text = timeout;
	        showMessage(getString(locale, "java.version.error").format(text));
	        return false;
	    }
	}
}

/**
 * Creates an APPLET with the given attributes and parameters, adding the archive
 * files from the given archive param.
 * @param attributes the APPLET attributes represented as a Hash.
 * @param parameters the APPLET parameters represented as a Hash.
 * @param archive the APPLET archive attribute represented as a Hash.
 */
function tiCreatePlayer (attributes, parameters) {
	// validate it is on a supported environment
	if(isValidEnvironment()){
		// validate there is applet attributes and then proccess them, if not do nothing
		if(attributes != null && attributes != 'undefined'){
			var applet = "<applet";
			if(isMacOS() && !"codebase" in attributes) {
				var codebase = location.href.replace(window.location.hash, "");
				codebase = codebase.replace(window.location.search, "");
				codebase = codebase.substring(0, codebase.lastIndexOf('/')+1) + '';
				applet += " codebase=\"" + codebase + "\"";
			}
	        		
			// builds the applet tag with the given attributes.
			// ***************** ATTRIBUTES *****************
	        var hashAttributes = new Hash();
			hashAttributes.concat(default_attributes);
			hashAttributes.concat(attributes);
			var finalAttributes = hashAttributes.entries;
	        for(var attribute in finalAttributes) {
	            var value = finalAttributes[attribute];
	            applet += " " + attribute + "=\"" + value + "\"";
	        }        
	        
	        if(isMacOS()) {
		        // ***************** ARCHIVE *****************
		        archive = default_archive;
		        var osName = isMacOS() ? "mac" : "win";
		        applet += " archive=\"";
		        for(var arch in archive) {
		            // check if archive if available for this platform
		            if(archive[arch] == true) {
		                applet += osName + "/" + arch + ",";
		            }
		        }
		        applet += "\"";
		        applet += ">";
	        }     
		        
	        // ***************** PARAMETERS *****************
	        var hashParameters = new Hash();
	        hashParameters.concat(default_parameters);
	        hashParameters.concat(parameters);
	        var finalParameters = hashParameters.entries;        
	        if(finalParameters != null && finalParameters != 'undefined') {
	            // iterates through the parameters. Keep the nspirefile 
	            // parameter at the end for relative addressing support.
	            for(var parameter in finalParameters) {
	                var value = finalParameters[parameter];
	                if(parameter != 'nspirefile') {
	                    applet += "<param name=\"" + parameter + "\" value=\"" +
	                        value + "\">";
	                }
	            }
	            if(isWinOS()) {
	            	applet += "<param name=\"" + "jnlp_href" + "\" value=\"" +
	            		"nspire-player-win-web.jnlp" + "\">";
	            }
	            // relative addressing support.
	            var nspirefile = finalParameters['nspirefile'];
	            if(nspirefile != null && nspirefile != 'undefined' && 
	                nspirefile != '') {
	                applet += "<param name=\"nspirefile\" value=\"" +
	                    tiParseRelativeAddressing(nspirefile) + "\">";
	            }
	        }        
	        applet += "</applet>";
	        // writes the applet tag.
	        document.write(applet);
		}
	}
}

/**
 * Validates if the given url is a relative address then prepend the 
 * window.locationon. Returns the parsed URL if the given url value 
 * is a relative address, otherwise the given url.
 * @param param the URL parameter.
 * @return the parsed URL if the given url value is a relative address, 
 * otherwise the given url.
 */
function tiParseRelativeAddressing(param) {
    var urlRegex = /^([A-Za-z]+:\/*).*/ig;
    // checks if it stars with protocol.
    if(!urlRegex.test(param)) { 
        var href = window.location.href.substring(
            0, window.location.href.lastIndexOf('/'));
        return unescape(href + "/" + param);
    } 
    return param;
}

/**
 * Opens the given URL document in the APPLET with the given id and sets the
 * given card id.
 */
function openDocument(id, url, cardid) {
    var applet = document.getElementById(id);
    if(cardid == null || !isNumber(cardid) || cardid.replace(/\s/g,'') == ''){
    	cardid = 0;
    }
    if(applet != 'undefined' && applet != '') {
        applet.openDocument(url, cardid);        
    }
}

/**
 * Checks wheter a specified attribute is a number
 * @param parameter
 * @returns true/false
 */
function isNumber (parameter) {
	return ! isNaN (parameter-0);
}


/**
 * Redirects to the given nextPage and checks if there is a query portion in the 
 * current location by getting window.location.search, if so then concat it in 
 * the new page. 
 * @param nextPage the next page.
 */
function redirect(nextPage) {
    var src = window.location.search;
    if(src != null && src != "" && typeof(src) != 'undefined') {
        window.location=nextPage+src;
    } else {
        window.location=nextPage;
    }
}

/**
 * Gets the player url regarding with the OS platform and append the 
 * window.location.search if present.
 * @returns the player url regarding with the OS platform and append the 
 * window.location.search if present.
 */
function getPlayerUrl() {
	
    var src = window.location.search;
    var originalHash = window.location.hash;
    var url = (isMacOS()) ? "nspire-player-mac.html" : "nspire-player-win.html";
    
    if(src != null && src != "" && typeof(src) != 'undefined') {
    	var completeURL = url + src;
    } else {
    	completeURL = url;
    }
    
    if(originalHash != null || originalHash != "" || typeof(originalHash) != 'undefined'){
    	completeURL = completeURL + originalHash;
    	
    	// replace all # characters by his code (%23)
        completeURL = completeURL.replace(/#/g,"%23");
        // document.write("Replacement the # symbol in the URL: " + completeURL );
    	
    }

    return completeURL;
}
/** 
 * Returns true if the next generation of Java Plug-in enabled, false otherwise.
 * In Windows will use deployJava#isPlugin2() and in mac will seek into the 
 * navigator.plugins to check if JavaPluginCocoa is NOT present.
 * @returns Returns true if the next generation of Java Plug-in enabled, 
 * false otherwise
 */
function isNextGenerationOfJavaPluginEnabled() {
    return (isMacOS() && !isPluginInstalled(
            'Switchable Java Plug-in for WebKit', 'JavaPluginCocoa.bundle')) || 
            (isWinOS() && deployJava.isPlugin2());
    
}
/**
 * Returns a OS string. Returns "win" if Windows, "mac" is Mac OS X.
 * @returns "win" if Windows, "mac" is Mac OS X.
 */
function getOSName() {
    return isWinOS() ? "win" : "mac";
}
/**
 * Returns true if the passed plugin args exist in navigator.plugins, false otherwise.
 * @returns true if the passed plugin args exist in navigator.plugins, false otherwise.
 */
function isPluginInstalled() {
    // refresh the list of plug-ins in case new were added.
    navigator.plugins.refresh(false);
    // check if there are plugins installed
    if(navigator.plugins && navigator.plugins.length > 0 && 
        isPluginInstalled.arguments && isPluginInstalled.arguments.length > 0) {
        // for each plugin in the navigator 
        var plugins = isPluginInstalled.arguments;
        // keep plugin by index, seems like foreach way does not work properly
        for (i=0; i < navigator.plugins.length; i++ ) {
            // for each given plugin name check if exist in the current plugin 
            for(j=0; j < plugins.length; j++) {
                var plugin = plugins[j];
                // if any match then return true
                if( (navigator.plugins[i].name.indexOf(plugin) >= 0) || 
                    (navigator.plugins[i].description.indexOf(plugin) >= 0) || 
                    (navigator.plugins[i].filename.indexOf(plugin) >= 0)) {
                    // this plugin was found
                    return true;
                }   
            }
        }
    }
    return false;
}
///**
// * Gets the translated strings regarding the browser locale.
// * @param id the string id.
// * @return the translated strings if defined, 'undefined' string otherwise.
// */
//function getString(id) {
//    return getLocaleString(getBrowserLocale(), id);
//}
//
///**
// * Gets the translated strings regarding the browser locale.
// * @param id the string id.
// * @return the translated strings if defined, 'undefined' string otherwise.
// */
//function getLocaleString(locale, id) {
//    document.write("<br/>Locale: " + locale);
//    document.write("<br/>Id: " + id);
//    if(typeof(strings) == 'undefined') {
//        importDependency('http://localhost/nspire-performance/application/js/strings/strings.js');
//    }
//    document.write("<br/>Strings: " + typeof(strings) + "<br/>");
//    if(locale == null || locale == "" || typeof(locale) == 'undefined') {
//        return 'undefined';
//    }
//    if(id == null || id == "" || typeof(id) == 'undefined') {
//        return 'undefined';
//    }
//    return strings[locale][id];
//}
