@echo off
echo Starting TI-Nspire(TM) Document Player Installation...
setlocal enabledelayedexpansion

set INSTALLER_JNLP_FILE=nspire-player-jnlp-installer.jnlp
set NEW_INSTALLER_JNLP_FILE=new-nspire-player-jnlp-installer.jnlp
set SEARCHTEXT=''
set MIN_VER=1.6.0_26
set TXT_TEMP_FILE=jv.txt
set TXT_PATH_FILE=java_path_TIplayer.txt
set ISJAVAINSTALLED=false
set registry_path=

set CD_PATH=%~dp0

REM Getting javaws and java paths from registry
set temp_path_file="%APPDATA%\%TXT_PATH_FILE%"

REM Getting javaws and java paths from jarfile registry due to Java 7 Update 4

FOR /F "tokens=2*" %%A IN ('REG QUERY "HKEY_CLASSES_ROOT\jarfile\shell\open\command" /v ""') DO echo %%A %%B > %temp_path_file%

REM Checking if file was created. If not, go to get java path from another registry
IF NOT EXIST %temp_path_file% GOTO get_javaws_path_from_JNLPfILE

REM Getting java path by creating a temporary file in appdata folder
for /f "eol= tokens=* delims= usebackq" %%i in (%temp_path_file%) do (
 set registry_path=%%i
)

REM Getting java path from string value of the registry
set registry_path=%registry_path:"=*%
set list=%registry_path%
echo.list %list%
 
for /f "tokens=1,2,3,4,5 delims=*" %%a in ("%list%") do set one=%%a&set two=%%b&set three=%%c&set four=%%d&set five=%%e
echo.1   : [%one%]
echo.JavaPath   : [%two%]
echo.3   : [%three%]
echo.4   : [%four%]
echo.5   : [%five%]

set two=%two:\javaw.exe=%
set registry_path=%two%

echo Path from jarfile registry jarfile: [%registry_path%]

REM Deleting temporary file, if existed
IF EXIST %temp_path_file% del %temp_path_file%


IF NOT EXIST "%registry_path%\javaws.exe" GOTO get_javaws_path_from_JNLPfILE

IF NOT EXIST "%registry_path%\java.exe" GOTO get_javaws_path_from_JNLPfILE

REM If registry path contains a value, continue with installation process
IF NOT "%registry_path%" == "" GOTO continue_installation_process


:get_javaws_path_from_JNLPfILE
FOR /F "tokens=2*" %%A IN ('REG QUERY "HKEY_CLASSES_ROOT\JNLPFile\Shell\Open\Command" /v ""') DO echo %%A %%B > %temp_path_file%

REM Checking if file was created. If not, go to get java path from another registry
IF NOT EXIST %temp_path_file% GOTO get_javaws_path_from_HKLM

REM Getting java path by creating a temporary file in appdata folder
for /f "eol= tokens=* delims= usebackq" %%i in (%temp_path_file%) do (
 set registry_path=%%i
)

REM Getting java path from string value of the registry
set registry_path=%registry_path:"=*%
set list=%registry_path%
echo.list %list%
 
for /f "tokens=1,2,3,4,5 delims=*" %%a in ("%list%") do set one=%%a&set two=%%b&set three=%%c&set four=%%d&set five=%%e
echo.1   : [%one%]
echo.JavaPath   : [%two%]
echo.3   : [%three%]
echo.4   : [%four%]
echo.5   : [%five%]

set two=%two:\javaws.exe=%
set registry_path=%two%

echo Path from JNLPFile registry: [%registry_path%]

REM Deleting temporary file, if existed
IF EXIST %temp_path_file% del %temp_path_file%

IF NOT EXIST "%registry_path%\javaws.exe" GOTO get_javaws_path_from_HKLM

IF NOT EXIST "%registry_path%\java.exe" GOTO get_javaws_path_from_HKLM

REM If registry path contains a value, continue with installation process
IF NOT "%registry_path%" == "" GOTO continue_installation_process

:get_javaws_path_from_HKLM
REM get javaws path from HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\javaws.exe\(Path - Value)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\javaws.exe" /v Path') DO SET registry_path=%%B
echo registry_path from HKLM [%registry_path%]

IF NOT EXIST "%registry_path%\javaws.exe" GOTO EOF

IF NOT EXIST "%registry_path%\java.exe" GOTO EOF

IF "%registry_path%" == "" GOTO EOF

:continue_installation_process
REM Getting javaws and java paths based on the registry value
set JAVAWS_PATH="%registry_path%\javaws.exe"
ECHO javaws path: [%JAVAWS_PATH%]
set JAVA_PATH="%registry_path%\java.exe"
ECHO java path: [%JAVA_PATH%]

set temp_file="%APPDATA%\%TXT_TEMP_FILE%"

IF %JAVA_PATH% == "" goto EOF

%JAVA_PATH% -version 2>&1 | findstr "version" > %temp_file%
cd "%APPDATA%"
%HOMEDRIVE%

REM Get Java Version
for /f "tokens=3" %%g in (%TXT_TEMP_FILE%) do (    
    set JAVA_VER=%%g
)

echo JAVA VERSION: %JAVA_VER%
del %TXT_TEMP_FILE%

IF "%JAVA_VER%" == "" goto EOF

REM Replacing . and _ to 0 in order to compare java versions
set JAVA_VER=%JAVA_VER:"=%
set JAVA_VER=%JAVA_VER:.=0%
set JAVA_VER=%JAVA_VER:_=0%

REM Validating if java version is 5 characters long. If so, 000 is added
set #=%JAVA_VER%
set length=0
:loop
if defined # (set #=%#:~1%&set /A length += 1&goto loop)

if %length%==5 set JAVA_VER=%JAVA_VER%000

set MIN_VER=%MIN_VER:.=0%
set MIN_VER=%MIN_VER:_=0%

if %JAVA_VER% EQU %MIN_VER% GOTO install_player
if %JAVA_VER% GTR %MIN_VER% GOTO install_player
if %JAVA_VER% LSS %MIN_VER% goto EOF

:install_player
REM There is a valid Java version installed. Install Player
echo INSTALLER LAUNCH PATH: %CD_PATH%
set ISJAVAINSTALLED="true"
set FOLDER_NAME="TI-NspireDocumentPlayer"
set JNLP_NAME="nspire-player-win-zeroconn.jnlp"
set NEW_JNLP_NAME="new-nspire-player-win-zeroconn.jnlp"

cd "%APPDATA%"

%HOMEDRIVE%

REM Remove the TI-NspireDocumentPlayer folder
rmdir /Q /S %FOLDER_NAME%
REM Making a Home folder
mkdir %FOLDER_NAME%
cd %FOLDER_NAME%

REM Prompting the destination folder
set DEST_FOLDER=%CD%

REM Copying files from current folder to destination folder
REM xcopy "%CD_PATH%*" "%DEST_FOLDER%" /D /E /C /R /H /I /K /Y
xcopy "%CD_PATH%application" "%DEST_FOLDER%\application" /D /E /C /R /H /I /K /Y

REM Prompting the application folder
set APP_PATH="%DEST_FOLDER%\application"
cd %APP_PATH%

REM Modify codebases in jnlp files for zero conn offline player
for /f "tokens=1,* delims=" %%A in ( '"type %INSTALLER_JNLP_FILE%"') do (
SET string=%%A
SET modified=!string:%SEARCHTEXT%='file:///%CD%'!
SET modified=!modified:%INSTALLER_JNLP_FILE%=%NEW_INSTALLER_JNLP_FILE%!
 
echo !modified! >> %NEW_INSTALLER_JNLP_FILE%
)
 
for /f "tokens=1,* delims=" %%A in ( '"type %JNLP_NAME%"') do (
SET text=%%A
SET tmodified=!text:%SEARCHTEXT%='file:///%CD%'!
SET tmodified=!tmodified:%JNLP_NAME%=%NEW_JNLP_NAME%!
SET tmodified=!tmodified:%INSTALLER_JNLP_FILE%=%NEW_INSTALLER_JNLP_FILE%!

echo !tmodified! >> %NEW_JNLP_NAME%
)

echo java path %JAVAWS_PATH%
echo app data %APP_PATH%
REM Installing and launching jnlp file
%JAVAWS_PATH% -codebase file:/%APP_PATH% -import %NEW_JNLP_NAME%
%JAVAWS_PATH% %NEW_JNLP_NAME%
echo TI-Nspire(TM) Document Player Installation completed...

:EOF 
IF %ISJAVAINSTALLED% == "true" goto COMPLETED

set Key="HKEY_CURRENT_USER\Control Panel\International"
for /F "tokens=3" %%a in ('reg query %Key%  ^| find /i "sLang"') do set LANGUAGE=%%a
set LANGUAGE=%LANGUAGE:~0,2%

set MESSAGE_FILE="%CD_PATH%/application/messages/%LANGUAGE%_java_not_installed.html"
echo CD_PATH %CD_PATH%
if not exist %MESSAGE_FILE% goto OPEN_DEFAULT
	%MESSAGE_FILE%
	goto COMPLETED

:OPEN_DEFAULT
"%CD%/application/messages/en_java_not_installed.html"

:COMPLETED